require 'studio_game/clumsy_player'

module StudioGame

    describe ClumsyPlayer do

        before do
            @player = ClumsyPlayer.new("klutz")
        end

        it "only gets half the point value for each treasure" do
            @player.points.should == 0

            hammer = Treasure.new(:hammer, 50)
            @player.found_treasure(hammer)
            @player.found_treasure(hammer)
            @player.found_treasure(hammer)

            @player.points.should == 75

            crowbar = Treasure.new(:crowbar, 400)
            @player.found_treasure(crowbar)

            @player.points.should == 275

            yielded = []
            @player.each_found_treasure do |treasure|
                yielded << treasure
            end

            yielded.should == [Treasure.new(:hammer, 75), Treasure.new(:crowbar, 200)]
        end

        context "Boosted by 10 clumsy player"
            before do
                @initial_health = 100
                @boost_factor = 10        
                @player = ClumsyPlayer.new("booster", 100, 10)
            end

            it "gets boosted 10 times when w00ted" do
                @player.w00t
                @player.health.should == @initial_health + 15 * @boost_factor
            end
    end
end
